<%@LANGUAGE="VBSCRIPT"%>
<%
option explicit

'===================================================
'Copyright 2005 Patrick Robin, Host Forest, all rights reserved
'
'All Host Forest software is provided for free under a linkware license.
'You may modify any part of the software at your own risk, but the software
'(altered or otherwise) may not be distributed to entities beyond the
'license holder without the explicit written permission of the copyright holder.
'
'You may not remove, alter or otherwise disable all or any of the hyperlinks
'to the Host Forest website (http://www.hostforest.co.uk). All images, links or
'text must remain unchanged and intact and visible when the pages are viewed
'unless you first obtain explicit written permission from the copyright holders.
'
'Permission to remove the links, images and branding on a site by site basis
'basis can be obtained by purchasing the appropriate license from Host Forest
'by visiting http://www.hostforest.co.uk/Purchase/default.asp 
'
'You may not pass of in part or in whole any part of this software, including
'images and source code, as your own work. You may use parts of this program in
'your own private works, including images and source code, but you may NOT
'redistribute, repackage, sublicense or sell in part or in whole any part of
'this program regardless of any modifications that may have been made without
'the express written permission of the copyright holder.
'
'This software is provided WITHOUT warranty, either expressed or implied,
'including, but not limited to, the implied warranties of merchantability and
'fitness for a particular purpose. 
'===================================================

'set time session and disable caches
session.lcid = 2057
response.buffer = true
response.expires = 60
response.expiresabsolute = now() - 1
response.addheader "pragma","no-cache"
response.addheader "cache-control","private"
response.cachecontrol = "no-cache"
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>

<!--#include virtual="/Includes/site-dataconnection.asp"-->
<!--#include virtual="/Includes/func-common.asp"-->
<!--#include virtual="/Includes/inc-configuration.asp"-->
<!--#include virtual="/Includes/inc-common.asp"-->

<%
'dimension variables
dim strType, strError, strHeader, strRedirect, strMessage

'load and check variables
strType = request.querystring("Type")
strError = request.querystring("Error")
strRedirect = request.querystring("Redirect")
%>

<title><%=strSiteTitle%> >> Error</title>

<!--#include virtual="/Includes/inc-metadata.asp"-->

<link rel="stylesheet" type="text/css" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />
<link rel="shortcut icon" href="<%=strSiteLocation%>/Admin/Includes/inc-stylesheet.css" />

</head>

<body>
	
	<div id="container">
		
		<div id="header">
			<!--#include virtual="/Admin/Includes/inc-header.asp"-->
		</div>
		
		<div id="centre">
			
			<div id="notification">
				<%
				select case strType
						
					case "Administration"
						
						strHeader = "Administration error"
						
						select case strError
							case "Permissions"
								strMessage = "You do not have sufficient user permissions to access this page."
							case "Logged"
								strMessage = "You are not logged in to "& strSiteTitle &". Please log in to access the administration panel."
						end select
					
					case "Account"
						
						strHeader = "Account error"
						
						select case strError
							case "Name"
								strMessage = "You have not entered a valid name."
							case "Password"
								strMessage = "You have not entered a valid password for your account."
						end select
						
					case "Users"
						
						strHeader = "Users error"
						
						select case strError
							case "User"
								strMessage = "You have not selected a valid user."
							case "Name"
								strMessage = "You have not entered a valid username."
							case "Password"
								strMessage = "You have not entered a valid password for your account."
							case "Administrator"
								strMessage = "You cannot delete or change the user level of the default Administrator."
							case "Duplicate"
								strMessage = "The username and/or email address that you have specified is already in use."
							case "Self"
								strMessage = "You cannot edit your own user account through the user editing page, please use your account section."
						end select
					
					case "General"
						
						strHeader = "General settings error"
						
						select case strError
							case "Name"
								strMessage = "You must enter a valid name for your site."
							case "Theme"
								strMessage = "You have not selected a valid theme."
							case "Location"
								strMessage = "You have not entered a valid location for your site."
						end select
						
					case "Folders"
						
						strHeader = "Folder error"
						
						select case strError
							case "Name"
								strMessage = "You have not entered a valid folder name. Folder names can only contain letters and cannot contain any spaces."
							case "Folders"
								strMessage = "There has been a problem retrieving the folder details from the database, please check your installation."
							case "Invalid"
								strMessage = "You have not specified a valid folder for deletion."
							case "System"
								strMessage = "The folder that you have specified is a system folder and cannot be deleted."
							case "Pages"
								strMessage = "The folder that you have specified still contains pages, you must delete any pages that are assigned to the folder before it can be deleted."
						end select
					
					case "Page"
						
						strHeader = "Page error"
						
						select case strError
							case "Type"
								strMessage = "You have not specified a valid page type to add."
							case "Title"
								strMessage = "You have not specified a valid page title."
							case "Name"
								strMessage = "You have not entered a valid page name. Page names can only contain letters and cannot contain any spaces."
							case "Address"
								strMessage = "You have not specified a valid link page address."
							case "Folder"
								strMessage = "You have not specified a valid folder."
							case "Duplicate"
								strMessage = "A page with that title or name already exists in the specified folder."
							case "Invalid"
								strMessage = "You have specified an invalid page."
							case "Order"
								strMessage = "You have not selected a valid order for the page."
						end select
					
					case "Files"
						
						strHeader = "Files error"
						
						select case strError
							case "Folder"
								strMessage = "The upload folder that you have specified is invalid."
							case "Upload"
								strMessage = "You have not specified any valid files to upload."
						end select
					
					case else
						strHeader = "General error"
						strMessage = "There was an unknown error processing your request."
						strRedirect = "/default.asp"
						
				end select
				
				'display error message
				response.write("<h1>"& strHeader &"</h1>")
				response.write(strMessage &" Please click <a href='"& strSiteLocation & strRedirect &"' title='"& strSiteTitle &"'>here</a> if you are not redirected within 5 seconds.")
				'set redirection
				response.addheader "Refresh", "5; URL="& strSiteLocation & strRedirect
				%>
			</div>
			
			<div class="clear"></div>
		</div>
		
		<div id="footer">
			<!--#include virtual="/Includes/inc-footer.asp"-->
		</div>
	</div>
	
</body>

</html>