<%
class clsUpload

	' This class is produced by 20/20 Applications Copyright (c) 2002 by 20/20 Applications of www.2020applications.com

	public totalbytes
	public Files
	public Forms
	public SafeFileExtensions
	public RestrictFileExtentions
	private binData

	private sub class_Initialize
		set Files = server.createobject("Scripting.Dictionary")
		set Forms = server.createobject("Scripting.Dictionary")
		RestrictFileExtentions = False
		SafeFileExtensions = ""
		totalbytes = 0
		server.scripttimeout = 600
		on error resume next
		response.CodePage = 1252
		on error GoTo 0
	end sub

	private sub class_Terminate
		set Files = nothing
		set Forms = nothing
		on error resume next
		response.CodePage = 65001
		on error GoTo 0
	end sub

	private function IsSafe(strFileName)
		if RestrictFileExtentions then

			if instr(SafeFileExtensions,lcase(right(strFileName,len(strFileName) - instrrev(strFileName,".")))) <> 0 then
				IsSafe = true
			else
				IsSafe = false
			end if

		else
			IsSafe = true
		end if
	end function

	public Default function Upload(ByVal strUploadPath)

		Upload = False
	
		dim tokenNewLine
		dim tokenTerminate
		dim tokenContentDisposition
		dim tokenName
		dim tokenDoubleQuotes
		dim tokenFileName
		dim tokencontenttype
		dim lngBeginningPos
		dim lngEndPos
		dim strSeparator
		dim lngSeparatorPos
		dim lngCurrentPos
		dim strInputName
		dim lngBOF
		dim lngEOF
		dim objFileBlob
		dim strFileName
		dim strcontenttype
		dim strData
	
		totalbytes = request.totalbytes
	
		tokenNewLine = ConvertStringToMultiByteString(chr(13))
		tokenTerminate = ConvertStringToMultiByteString("--")
		tokenContentDisposition = ConvertStringToMultiByteString("Content-Disposition")
		tokenName = ConvertStringToMultiByteString("name=")
		tokenDoubleQuotes = ConvertStringToMultiByteString(chr(34))
		tokenFileName = ConvertStringToMultiByteString("filename=")
		tokencontenttype = ConvertStringToMultiByteString("Content-Type:")
	
		on error resume next
		
		binData = request.binaryread(totalbytes)
		if err.Number <> 0 then
			Upload = False
			exit function
		end if
	
		on error GoTo 0
	
		lngBeginningPos = 1
		lngEndPos = InstrB(lngBeginningPos,binData,tokenNewLine)
	
		if (lngEndPos-lngBeginningPos) <= 0 then
			exit function
		end if
	
		strSeparator = MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos)
		lngSeparatorPos = InstrB(lngBeginningPos,binData,strSeparator)
	
			do until (lngSeparatorPos >= InstrB(binData,strSeparator & tokenTerminate))
	
				lngCurrentPos = InstrB(lngSeparatorPos,binData,tokenContentDisposition)
				lngCurrentPos = InstrB(lngCurrentPos,binData,tokenName)
				lngBeginningPos = lngCurrentPos + 6
				lngEndPos = InstrB(lngBeginningPos,binData,tokenDoubleQuotes)
				strInputName = ConvertBinaryToString(MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos))
		
				lngBOF = InstrB(lngSeparatorPos,binData,tokenFileName)
				lngEOF = InstrB(lngEndPos,binData,strSeparator)
	
				if ((lngBOF <> 0) and (lngBOF < lngEOF)) then
		
					lngBeginningPos = lngBOF + 10
					lngEndPos =  InstrB(lngBeginningPos,binData,tokenDoubleQuotes)
		
					strFileName = replace(ConvertBinaryToString(MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos)),"/","\")
					strFileName = right(strFileName,len(strFileName)-instrrev(strFileName,"\"))
		
					lngCurrentPos = InstrB(lngEndPos,binData,tokencontenttype)
					lngBeginningPos = lngCurrentPos + 14
					lngEndPos = InstrB(lngBeginningPos,binData,tokenNewLine)
		
					strcontenttype = ConvertBinaryToString(MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos))
		
					lngBeginningPos = lngEndPos+4
					lngEndPos = InstrB(lngBeginningPos,binData,strSeparator) - 2
			
					strData = MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos)
			
					if IsSafe(strFileName) then
	
						set objFileBlob = New clsUploadedFile
						objFileBlob.UploadPath = strUploadPath
						objFileBlob.FileName = strFileName
						objFileBlob.contenttype = strcontenttype
						objFileBlob.Data = strData
	
						if objFileBlob.size > 0 then
							Files.Add LCase(strInputName),objFileBlob
						end if
	
					end if
	
				else
	
					lngCurrentPos = InstrB(lngCurrentPos,binData,tokenNewLine)
					lngBeginningPos = lngCurrentPos + 4
					lngEndPos = InstrB(lngBeginningPos,binData,strSeparator) - 2
					if not Forms.Exists(LCase(strInputName)) then
						Forms.Add LCase(strInputName),ConvertBinaryToString(MidB(binData,lngBeginningPos,lngEndPos-lngBeginningPos))
					end if
				end if
		
				lngSeparatorPos = InstrB(lngSeparatorPos + LenB(lngSeparatorPos),binData,strSeparator)
	
			LOOP
	
		Upload = True

	end function




	private function ConvertStringToMultiByteString(str)

		dim lngIndex
		dim strNew

		for lngIndex = 1 to len(str)
			strNew = strNew & chrB(AscB(Mid(str,lngIndex,1)))
		next

		ConvertStringToMultiByteString = strNew

	end function

	private function ConvertBinaryToString(bin)

		dim lngIndex
		dim strNew
	    strNew = ""

		for lngIndex = 1 to lenB(bin)
			strNew = strNew & chr(AscB(MidB(bin,lngIndex,1))) 
		next

		ConvertBinaryToString = strNew

	end function
	
end class


class clsUploadedFile

	public contenttype
	public Data
	public FileName
	public UploadPath

	private sub class_Initialize
		UploadPath = server.mappath("_clsUpload.asp")
	end sub

	private sub class_Terminate
	end sub
	
	public property get size
		size = lenB(Data)
	end property

	public function BuildPath
		dim objFSO
		set objFSO = server.createobject("Scripting.FileSystemObject")
		BuildPath = objFSO.BuildPath(UploadPath,FileName)
		set objFSO = nothing
	end function

	public property get FileExists
		dim objFSO
		set objFSO = server.createobject("Scripting.FileSystemObject")
		FileExists = objFSO.FileExists(BuildPath)
		set objFSO = nothing
	end property

	public property get FolderExists
		dim objFSO
		set objFSO = server.createobject("Scripting.FileSystemObject")
		FolderExists = objFSO.FolderExists(UploadPath)
		set objFSO = nothing
	end property

	public function Save
		dim strPath	
		dim objADOStream
		
		Save = False
		
		strPath = BuildPath
		
		set objADOStream = server.createobject("ADODB.Stream")
		objADOStream.Type = 1 'adTypeBinary
		objADOStream.open
		objADOStream.Write ConvertMultiByteStringToBinary(Data)
		objADOStream.SavetoFile strPath, 2 'adSaveCreateOverWrite
		set objADOStream = nothing
	
		Save = True

	end function

	private function ConvertMultiByteStringToBinary(bStr)
		dim binData
		dim lngMByteString
		dim objRs
		
	    lngMByteString = LenB(bStr)

		if lngMByteString > 0 then
			set objRs = server.createobject("ADODB.Recordset")
		    objRs.fields.Append "binData",205,lngMByteString 'adLongVarBinary,length
		    objRs.open
		    objRs.addnew
		    objRs("binData").appendchunk bStr & chrB(0)
		    objRs.update
			binData = objRs("binData").getchunk(lngMByteString)
		    objRs.close
			set objRs = nothing
		end if

		ConvertMultiByteStringToBinary = binData
	end function

end class
%>